<template>
  <div>
    <v-form ref="loginForm" lazy-validation>
      <div class="login-form">
        <IconifyIcon
          :icon="icons.personIcon"
          class="login-form__icon"
          height="115px"
          width="110px" />
        <div class="login-form__circle"></div>
        <v-text-field
          rounded filled
          label="E-mail"
          required
          class="login-form__field login-form__login-field"
          background-color="#FFFFFF"
          outlined
          :rules="[rules.required, rules.validEmail]"
          v-model="email"
          :error-messages="emailErrorMessages">
        </v-text-field>
        <v-text-field
          rounded filled
          :type="'password'"
          label="Password"
          class="login-form__field login-form__password-field"
          background-color="#FFFFFF"
          outlined
          :rules="[rules.min]"
          v-model="password"
          :error-messages="passwordErrorMassages">
        </v-text-field>
        <v-btn
          class="login-form__sign-in dark-btn"
          height="50"
          width="190"
          @click="validateAndSubmit"
          :disabled="submitted">SIGN IN
        </v-btn>
      </div>
    </v-form>
  </div>
</template>

<script>
import IconifyIcon from '@iconify/vue'
import personIcon from '@iconify/icons-bi/person'
import { mapMutations } from 'vuex'
import { LogIn } from "@/api/auth"
import { newAvatarS3Link } from "@/js/s3"

export default {
  name: 'Login',
  components: {
    IconifyIcon
  },

  data () {
    return {
      email: "",
      password: "",

      emailErrorMessages: "",
      passwordErrorMassages: "",

      submitted: false,

      icons: {
        personIcon
      },

      rules: {
        validEmail: email => /.+@.+\..+/.test(email) || 'E-mail must be valid',
        required: value => !!value || 'Required',
        min: v => (v && v.length >= 8) || 'At least 8 characters'
      }
    }
  },

  methods: {
    ...mapMutations([
      'updateUserID',
      'updateUserEmail',
      'updateUserFirstName',
      'updateUserLastName',
      'updateUserAvatar',
      'updateIsAuthed',
      'updateIsVerified',
      'updateUserFriends'
    ]),

    async validateAndSubmit() {
      if (this.$refs.loginForm.validate()) {
        this.submitted = true
        const result = await LogIn(this.email, this.password)
        this.submitted = false

        if (!result.status) {
          return
        }

        if (result.status === 200) {
          const data = result.data.data.data
          const user = result.data.data.included.find(item => item.id === data.id)

          this.updateIsVerified(data.attributes.is_verified)
          this.updateUserID(data.id)
          this.updateUserEmail(this.email)
          this.updateUserFirstName(user.attributes.first_name)
          this.updateUserLastName(user.attributes.last_name)
          this.updateUserAvatar(user.attributes.has_avatar ? newAvatarS3Link(data.id) : "/dummy.png")
          this.updateUserFriends(Array.from(user.relationships.friends.data, e => e.id))
          this.updateIsAuthed(true)

          await this.$router.push('/home')
          return
        }

        this.resetErrorFields()

        switch (result.status) {
          case 404:
            this.emailErrorMessages = 'Account with such email does not exist'
            break
          case 403:
            this.passwordErrorMassages = 'Invalid password'
            break
          default:
            this.$toasted.error('Oh no... Something bad happened')
        }
      }
    },

    resetErrorFields() {
      this.passwordErrorMassages = ""
      this.emailErrorMessages = ""
    }
  }
}
</script>

<style scoped>
.v-text-field--outlined >>> fieldset {
  border: 2px solid rgba(0, 0, 0, 0.32);
}
</style>

<style>
.login-form {
  width: 400px;
  height: 700px;
  margin-top: 35px;
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate(-50%, -50%);

  font-family: Roboto, fantasy;
  font-weight: normal;
  font-size: 30px;

  background: linear-gradient(168.72deg, #ececec 8.31%, rgba(11, 11, 11, 0.1));
  border: 1px solid rgba(85, 85, 85, 0.2);
  filter: drop-shadow(-1px -2px 4px rgba(0, 0, 0, 0.25));
  border-radius: 9px;
}

.login-form__icon {
  position: absolute;
  margin-top: 100px;
  margin-left: 145px;

  stroke: rgba(0, 0, 0, 1);
  stroke-width: 0.1px;
  color: rgba(89, 89, 89, 0.9);
  z-index: 1;
}

.login-form__circle {
  margin-top: 75px;
  position: relative;
  left: 50%;
  transform: translate(-50%, 0%);
  border-radius: 50%;
  width: 160px;
  height: 160px;

  border: 2px solid rgba(0, 0, 0, 0.20);
  background-color: #FDFDFD;
}

.login-form__field {
  margin-left: 40px !important;
  margin-right: 40px !important;
}

.login-form__login-field {
  margin-top: 140px !important;
}

.login-form__sign-in {
  margin-top: 40px;
  left: 50%;
  transform: translate(-50%, 0%);
}

.dark-btn {
  background: linear-gradient(180deg, rgba(62, 62, 62, 0.91) 0%, rgba(37, 37, 37, 0.91) 100%);
  box-shadow: 2px 4px 4px rgba(0, 0, 0, 0.75);
  border-radius: 15px !important;
  font-family: Roboto, serif;
  font-style: normal;
  font-weight: bold;
  font-size: 23px !important;
  color: #EEEEEE !important;

  filter: blur(0.3px);
}

legend {
  width: 0 !important;
}

.v-text-field__slot {
  margin-top: 3px;
}

input {
  margin-top: 0 !important;
}

input:-webkit-autofill,
input:-webkit-autofill:hover,
input:-webkit-autofill:focus,
input:-webkit-autofill:active  {
  -webkit-box-shadow: 0 0 0 30px white inset !important;
}

</style>
